import monotonic.monotonic.sklearn_wrappers as sklearn_wrappers
import pandas as pd
import numpy as np

data_file = 'uci_mammo_data.csv'

data = pd.DataFrame.from_csv(data_file, index_col = None)

X = np.array(data.iloc[:,0:-1])
y = np.array(data.iloc[:,-1])

feature_names = data.columns

fitter = sklearn_wrappers.monotonic_sklearn_fitter(num_steps = 5000, min_supp = 5, max_clauses = 2, prior_length_mean = 8, prior_gamma_l_alpha = 1., prior_gamma_l_beta = 0.1, temperature = 1)

predictor = fitter.fit(X,y,feature_names)
#predictor = fitter.fit(X,y) the feature_names argument is optional, but then you won't know the features used in each rule

training_scores = predictor.decision_function(X)

print 'the MAP rule list'
print predictor.train_info

print 'some scores:'
print training_scores[0:10]
